CodeForces 28D Don't fear, DravDe is kind(dp)

题意:给你一些四元组(v,c,l,r),要你选出一些作为组合,不能改变相对顺序,要求是对于其中一个,l_i是之上所有c_i之和,r_i是之下所有c_i之和。要你选出的组合sum(v_i)最大。

解法:因为对于一个组合来说,l_i是之上所有c_i之和,r_i是之下所有c_i之和,在加上当前的c_i,那么c_i+l_i+r_i是这个组合全部c_i之和,因此要成为一个组合,至少c_i+l_i+r_i之和得一样。我们把这类单独考虑,可以发现如果j是i的后面一个,那么c_i+l_i = l_j,我们可以从前往后递推,起点的l_i必须得是0,这样做l_i必定能满足条件,如果要r_i也满足条件,那么最后一个的r_i=0即可。可以列个组合试试,每个的c_i+l_i+r_i相同,l_i是前面c_i之后,第一个l_i是0,最后一个r_i是0,即能满足r_i是下面所有c_i之后。

所以在r_i是0的时候就是组合的最后一个。对比记录下就可以了。

AC代码:

#pragma comment(linker, "/STACK:102400000,102400000")
#include<cstdio>
#include<ctype.h>
#include<algorithm>
#include<iostream>
#include<cstring>
#include<vector>
#include<cstdlib>
#include<stack>
#include<queue>
#include<set>
#include<map>
#include<cmath>
#include<ctime>
#include<string.h>
#include<string>
#include<sstream>
#include<bitset>
using namespace std;
#define ll __int64
#define ull unsigned long long
#define eps 1e-8
#define NMAX 1000000000
#define MOD 1000000
#define lson l,mid,rt<<1
#define rson mid+1,r,rt<<1|1
#define PI acos(-1)
#define ALL(x) x.begin(), x.end()
#define INS(x) inserter(x, x.end())
template<class T>
inline void scan_d(T &ret)
{
    char c;
    int flag = 0;
    ret=0;
    while(((c=getchar())<'0'||c>'9')&&c!='-');
    if(c == '-')
    {
        flag = 1;
        c = getchar();
    }
    while(c>='0'&&c<='9') ret=ret*10+(c-'0'),c=getchar();
    if(flag) ret = -ret;
}
template<class T> inline T Max(T a, T b){ return a > b ? a : b; }
template<class T> inline T Min(T a, T b){ return a < b ? a : b; }
const int maxn = 100000+10;
struct node
{
    int id,v,c,l,r,sum;
    bool operator < (const node &t) const
    {
        return sum == t.sum ? id < t.id : sum < t.sum;
    }
};
node no[maxn];

int ans[2],pre[maxn],tmp[maxn];
map<int,pair<int,int> >mp;
stack<int>st;
int main()
{
#ifdef GLQ
    freopen("input.txt","r",stdin);
//    freopen("o.txt","w",stdout);
#endif
    int n;
    scanf("%d",&n);
    for(int i = 1; i <= n; i++)
    {
        scanf("%d%d%d%d",&no[i].v,&no[i].c,&no[i].l,&no[i].r);
        no[i].sum = no[i].c+no[i].l+no[i].r;
        no[i].id = i;
    }
    sort(no+1,no+1+n);
    no[n+1].sum = 4*maxn;
    int nct = 0;
    tmp[++nct] = 1;
    ans[0] = 0;
    for(int i = 2; i <= n+1; i++)
    {
        if(no[i].sum == no[i-1].sum) tmp[++nct] = i;
        else
        {
            mp.clear();
            for(int j = 1; j <= nct; j++)
            {
                node t = no[tmp[j]];
                if(t.l == 0)
                {
                    if(mp.find(t.c) == mp.end() || mp[t.c].first < t.v)
                    {
                        mp[t.c].first = t.v;
                        pre[t.id] = 0;
                        mp[t.c].second = t.id;
                        if(t.r == 0 && mp[t.c].first > ans[0])
                        {
                            ans[0] = t.v;
                            ans[1] = t.id;
                        }
                    }
                }
                else
                {
                    if(mp.find(t.l) != mp.end())
                    {
                        if(mp.find(t.l+t.c) == mp.end() || mp[t.l+t.c].first < mp[t.l].first+t.v)
                        {
                            mp[t.l+t.c].first = mp[t.l].first+t.v;
                            pre[t.id] = mp[t.l].second;
                            mp[t.l+t.c].second = t.id;
                        }
                        if(t.r == 0 && mp[t.l].first+t.v > ans[0])
                        {
                            ans[0] = mp[t.l].first+t.v;
                            ans[1] = t.id;
                        }
                    }
                }
            }
            nct = 0;
            tmp[++nct] = i;
        }
    }
//    printf("%d\n",ans[0]);
    for(int i = ans[1]; i ; i = pre[i])
        st.push(i);
    int sz = st.size();
    printf("%d\n",sz);
    while(!st.empty())
    {
        printf("%d%c",st.top(),sz == 1 ?'\n':' ');
        st.pop();
        sz--;
    }
    return 0;
}


  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
区间DP是一种动态规划的方法,用于解决区间范围内的问题。在Codeforces竞赛中,区间DP经常被用于解决一些复杂的字符串或序列相关的问题。 在区间DP中,dp[i][j]表示第一个序列前i个元素和第二个序列前j个元素的最优解。具体的转移方程会根据具体的问题而变化,但是通常会涉及到比较两个序列的元素是否相等,然后根据不同的情况进行状态转移。 对于区间长度为1的情况,可以先进行初始化,然后再通过枚举区间长度和区间左端点,计算出dp[i][j]的值。 以下是一个示例代码,展示了如何使用区间DP来解决一个字符串匹配的问题: #include <cstdio> #include <cstring> #include <string> #include <iostream> #include <algorithm> using namespace std; const int maxn=510; const int inf=0x3f3f3f3f; int n,dp[maxn][maxn]; char s[maxn]; int main() { scanf("%d", &n); scanf("%s", s + 1); for(int i = 1; i <= n; i++) dp[i][i] = 1; for(int i = 1; i <= n; i++) { if(s[i] == s[i - 1]) dp[i][i - 1] = 1; else dp[i][i - 1] = 2; } for(int len = 3; len <= n; len++) { int r; for(int l = 1; l + len - 1 <= n; l++) { r = l + len - 1; dp[l][r] = inf; if(s[l] == s[r]) dp[l][r] = min(dp[l + 1][r], dp[l][r - 1]); else { for(int k = l; k <= r; k++) { dp[l][r] = min(dp[l][r], dp[l][k] + dp[k + 1][r]); } } } } printf("%d\n", dp[n]); return 0; } 希望这个例子能帮助你理解区间DP的基本思想和应用方法。如果你还有其他问题,请随时提问。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值